%Test rpymat(angs) and rool_pitch_yaw_mat2(angs),
%angs=[roll,pitch,yaw]
%[roll(around x first),then pitch(around y),finally yaw(around z)]
%http://www.grc.nasa.gov/WWW/k12/airplane/rotations.html
%http://planning.cs.uiuc.edu/node102.html 

%demo_roll_pitch_yaw
function demo_roll_pitch_yaw()
clear
clc
%They are the same
R=rpymat([10,20,30]*pi/180);
R2=roll_pitch_yaw_mat2([10,20,30]*pi/180);
R-R2
rpyAng(R)*180/pi
rpyAng(R)*180/pi

% result ans =
%    1.0e-15 *
%          0   -0.1110         0
%          0         0         0
%          0         0         0
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% Author: Rodrigo Carceroni
% Disclaimer: This code comes with no guarantee at all and its author
%   is not liable for any damage that its utilization may cause.
%khw added 3.3002 , input angs is a 1x3 matrix,
%    angs(1) is yaw   angle about x-axis
%    angs(2) is pitch angle about y-aixs
%    angs(3) is roll  angle about z-axis
%then X'=RX+T; X,T are 3X1 matrixes for [X,Y,Z]' 3D corrd. and translations.
function R = rpyMat (angs)

% Return the 3x3 rotation matrix described by a set of Roll, Pitch and Yaw
% angles.

cosA = cos (angs(3));
sinA = sin (angs(3));
cosB = cos (angs(2));
sinB = sin (angs(2));
cosC = cos (angs(1));
sinC = sin (angs(1));

cosAsinB = cosA .* sinB;
sinAsinB = sinA .* sinB;

R = [ cosA.*cosB  cosAsinB.*sinC-sinA.*cosC  cosAsinB.*cosC+sinA.*sinC ;
      sinA.*cosB  sinAsinB.*sinC+cosA.*cosC  sinAsinB.*cosC-cosA.*sinC ;
        -sinB            cosB.*sinC                 cosB.*cosC         ];


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function R=roll_pitch_yaw_mat2(angs)
% % same as berlow
an_x=angs(1);
an_y=angs(2);
an_z=angs(3);
%below are Rcam
Rz=[cos(an_z)   -sin(an_z)   0
   sin(an_z)   cos(an_z)   0
    0           0           1];
Ry=[cos(an_y)   0           sin(an_y)
    0           1           0 
   -sin(an_y)    0           cos(an_y)];
Rx=[1           0           0
    0           cos(an_x)   -sin(an_x)
    0           sin(an_x)  cos(an_x)];
R= Rz*Ry*Rx ;%rotate x first, then y, final z

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
function angs = rpyAng (R)
%https://stackoverflow.com/questions/15022630/how-to-calculate-the-angle-from-rotation-matrix
% Returns a set of Roll, Pitch and Yaw angles that describe a certain 3x3
% transformation matrix. The magnitude of the Pitch angle is constrained
% to be not bigger than pi/2.

sinB = -R(3,1);
cosB = sqrt (R(1,1) .* R(1,1) + R(2,1) .* R(2,1));
if abs (cosB) > 1e-15
  sinA = R(2,1) ./ cosB;
  cosA = R(1,1) ./ cosB;
  sinC = R(3,2) ./ cosB;
  cosC = R(3,3) ./ cosB;
  angs = [atan2(sinC,cosC); atan2(sinB,cosB); atan2(sinA,cosA)];
else
  sinC = (R(1,2) - R(2,3)) ./ 2;
  cosC = (R(2,2) + R(1,3)) ./ 2;
  angs = [atan2(sinC,cosC); pi./2; 0];
  if sinB < 0
    angs = -angs;
  end;
end;
