%modified khw 2021.3.4
function demo_pose
%test pose estimation. Use number of pixesl for all measures

%% generate data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear
pixel_per_meter=5*10^-6; %5um_

f=4*10^-3/pixel_per_meter;%focal length =4mm

N=5; %N=num of features
randon_gen_tag=1;
if (randon_gen_tag==1)
    %X=(rand(3,N)*0.1+repmat(Z_center,1,N))/pixel_per_meter %repmat(Z_center,1,N),so two terms can add
    X=rand(3,N)*0.05/pixel_per_meter;
    
    % X=repmat([X;1],1,N) % homogenous coord)
else
    %data set A
    X=  1.0e+003 *...
        [3.2248    0.7283    9.2234    5.3825    9.5191
        9.7615    7.5122    3.2702    4.6329    0.7627
        2.7821    8.3119    8.0407    8.2075    7.0867]
% %set 2103304a
%     X =   1.0e+03 *...
%     [4.8976    7.0936    6.7970    1.1900    3.4039
%     4.4559    7.5469    6.5510    4.9836    5.8527
%     6.4631    2.7603    1.6261    9.5974    2.2381]
%     
% %set 2103304b
% % X =    1.0e+03 *
%     X =   1.0e+03 *...
%     [7.5127    6.9908    5.4722    2.5751    8.1428
%     2.5510    8.9090    1.3862    8.4072    2.4352
%     5.0596    9.5929    1.4929    2.5428    9.2926]

end ;

%motion of object [ang_x,ang_y,ang_z,T1,T2,T3], ang_z in radian,T in pixles
Z_center=1/pixel_per_meter; %[0 0 1]' %center of gravity of the object= 1 meter from the camera center
%so the true postion of the object is [0,0,20000]

an_x=5; %tye rotation angle in degrees
an_y=10;
an_z=20;
theta=([0 0 Z_center an_x*pi/180 an_y*pi/180 an_z*pi/180]'); % true angles ,make it radian

Z_init=1.001/pixel_per_meter;
theta_guessed=([0 0 Z_init  0*pi/180 0*pi/180 0*pi/180]'); %first guess

R=roll_pitch_yaw_2R([theta(4), theta(5),theta(6)]);
R_guessed=roll_pitch_yaw_2R([theta_guessed(4), theta_guessed(5),theta_guessed(6)]);

X_new=R*X+repmat(theta(1:3),1,N); %X_new (Actual)position of the object

% %image is projected from X_new, ixy=[u,v]'=image point
% figure(1)
% clf
% hold on
% for j=1:N
%     ixy(2*(j-1)+1,1)=[f*X_new(1,j)/X_new(3,j)];
%     ixy(2*(j-1)+2,1)=[f*X_new(2,j)/X_new(3,j)];
%     plot(ixy(2*(j-1)+1,1), ixy(2*(j-1)+2,1),'ro');
% end

actual_image=[f*X_new(1,:)./X_new(3,:)
    f*X_new(2,:)./X_new(3,:)];

%plot images
figure(1)
clf
hold on
plot(actual_image(1,:),actual_image(2,:),'ro');
title('image features')

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%function Soultion - ishii(Model, ActualImg, InitTr, fLen, numIter)
%pose_Solution=ishii(X,actual_image, [R_guessed,[0 0 Z_init]'],f,100,actual_image);%bug
pose_Solution=pose_est(X,actual_image, [R_guessed,[0 0 Z_init]'], f,100);

'Ground truth : translation inn pixels'
[0 0 Z_center]

'Result: Translation in pixels'
pose_Solution(1:3) %translation in pixels

'Ground truth rotation in degrees'
[an_x,an_y,an_z]


'Result: Rotation angles in degrees'
pose_Solution(4:6)*180/pi %turn soluition angle from radian into degree

%%%%%%%%%%%%%%%%%

