function Solution = ishii(Model, ActualImg, InitTr, fLen, numIter,actual_image)
%Model=  a 3x n matrix
%ActulImg = 2xn matrix
%InitTr = 4x4 matrix
%fLen=foccal length
%numIter=number of iterations
%Soultion = 6x1

[m n]= size(Model);
%preallocation optimzation

ReconImg=zeros(2,n);
err=zeros(2.*n,1);
Jacob=zeros(2.*n,6);

% Extract the initial estimates for the parameers
Rot=InitTr(1:3,1:3);
dists=InitTr(1:3,4);
%main loop
iter =0;
while 1
    %project the model
    RMod=Rot * Model;
    for r=1:2
        ReconImg(r,:)=fLen.*(RMod(r,:)+dists(r)) ./ (RMod(3,:)+dists(3));
    end
    
    %%%plot images%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    figure(1)
    clf
    hold on
    plot(actual_image(1,:),actual_image(2,:),'ro');
    plot(ReconImg(1,:),ReconImg(2,:),'bx');
    title('image features')
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
    Dif=ActualImg - ReconImg;
    %check the top doniston
    if(iter >numIter(1))
        break;
    else
        iter=iter +1;
    end;
    %compute the error vector and the jaco matrix
    for pt =1:n
        pt2=2 .* pt;
        err(pt2-1:pt2)=Dif(:,pt);
        
        x=Model(1,pt);
        y=Model(2,pt);
        z=Model(3,pt);
        
        a=x+dists(1);
        b=y+dists(2);
        c=z+dists(3);
        
        fc=fLen ./c;
        fcx=fc .* x;
        fcy=fc .* y;
        fcz=fc .* z;
        fc2=fc ./ c;
        fc2a=fc2 .* a;
        fc2b=fc2 .* b;
        fc2ax=fc2a .* x;
        fc2ay=fc2a .* y;
        fc2xb=fc2b .* x;
        fc2by=fc2b .* y;
        
        Jacob(pt2-1:pt2,:)=...
            [fc 0   -fc2a    -fc2ay         fcz+fc2ax    -fcy
            0   fc  -fc2b    -fcz-fc2by     fc2xb         fcx];
    end;
    %solve the resultuing sys
    delta=Jacob \ err;
    dists = dists + delta(1:3);
    Rot= rpyMat (delta(4:6)) * Rot;
    dists
    rpyAng(Rot)
    error(iter)=sum(err.*err)
    
end;
%record the solution
Solution = [dists;rpyAng(Rot)];
figure(2)
clf
size(error)
plot(error(1,:))
error(iter) %last error







