function sfm1
%test pose estimation. Use number of pixesl for all measures 

%% generate data %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
clear
pixel_per_meter=5*10^-6; %5um

f=4*10^-3/pixel_per_meter;%focal length =4mm

N=50; %N=num of features
randon_gen_tag=1;
if (randon_gen_tag==1)
 %X=(rand(3,N)*0.1+repmat(Z_center,1,N))/pixel_per_meter %repmat(Z_center,1,N),so two terms can add
X=rand(3,N)*0.05/pixel_per_meter;

 % X=repmat([X;1],1,N) % homogenous coord)
else
%     N=4
%     X=  [0.0000    0.0000    0.0000    0.0000
%         -0.1997   -0.1997   -0.1997   -0.1997
%         1.9900    1.9900    1.9900    1.9900]
       
end ;
    

    %motion of object [ang_x,ang_y,ang_z,T1,T2,T3], ang_z in radian,T in pixles
Z_center=1/pixel_per_meter; %[0 0 1]' %center of gravity of the object= 1 meter from the camera center
theta=([0 0 Z_center 0*pi/180 1*pi/180 0*pi/180]'); %make it radian

Z_init=1.001/pixel_per_meter;
theta_guessed=([0 0 Z_init  0*pi/180 0.5*pi/180 0*pi/180]'); %first guess


R=rpyMat([theta(4), theta(5),theta(6)]);

X_new=R*X+repmat(theta(1:3),1,N); %X_neww new position of the object

%image is projected from X_new, ixy=[u,v]'=image point
figure(1)
clf
hold on
for j=1:N
    ixy(2*(j-1)+1,1)=[f*X_new(1,j)/X_new(3,j)];
    ixy(2*(j-1)+2,1)=[f*X_new(2,j)/X_new(3,j)];
    plot(ixy(2*(j-1)+1,1), ixy(2*(j-1)+2,1),'ro');
   
end
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%%%%%%%%%%%%%%%%%%% pose estimation %%%%%%%%%%%%%%%%%%%%%%%%%
% given ixy, f, X(=model),theta_guessed, find thesta (pose); u=[ix;iy]
%u - u_guessed = J * (theta - theta_guessed) %we want to find theta

   %%% X_guessed=R_guessed*X+repmat(theta_guessed(1:3),1,N)+repmat([0,0,Zinit]',1,N)

   R_guessed=rpyMat([theta_guessed(4),theta_guessed(5),theta_guessed(6)]);
for k=1:100 % ietration to find solution of theta
    figure(1) %plot model project points
    clf
    hold on
    for j=1:N
        ixy(2*(j-1)+1,1)=[f*X_new(1,j)/X_new(3,j)];
        ixy(2*(j-1)+2,1)=[f*X_new(2,j)/X_new(3,j)];
        plot(ixy(2*(j-1)+1,1), ixy(2*(j-1)+2,1),'ro');
   
    end
   
 
    figure(1) %plot guessed points
    display_tag=1
    for j=1:N
        X_guessed=R_guessed*X+repmat(theta_guessed(1:3),1,N) ;
        ixy_guessed(2*(j-1)+1,1)=[f*X_guessed(1,j)/X_guessed(3,j)];
        ixy_guessed(2*(j-1)+2,1)=[f*X_guessed(2,j)/X_guessed(3,j)];
        if display_tag==1
            plot(ixy_guessed(2*(j-1)+1,1), ixy_guessed(2*(j-1)+2,1),'b+');
        end
    end
        
    %function J=JacobRT(flen, model, rt),rt must be 3x4x1,rt=[R(3x3),T(3x1)]
    X_homo=[X;ones(1,N)];
    J_guessed=zeros(2*N,6); %init
    % you have 2 options: JacobRT and JacobRT_full_i
    J_guessed=JacobRT(f,X_homo,[R_guessed,theta(1:3)])
%     cond(J_guessed)
     delta_ixy=(ixy - ixy_guessed); %just to show it
    pinv(J_guessed);
    theta=J_guessed\ delta_ixy+theta_guessed;
    delta_theta=theta-theta_guessed
   
    R_guessed=rpyMat([delta_theta(4), delta_theta(5), delta_theta(6)])*R_guessed
    delta_theta(4:6)*180/pi
    pause
    k
    %theta_guessed-theta
    theta_guessed=theta
    error(k)=sum(delta_ixy.*delta_ixy)/N
    'the above is theta_guessed-theta, error=sum_sq_error,  hit key to continue'
pause
   
end
figure(2)
clf
plot(error)

%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%               functions 
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%

%extended lowe
function J=JacobRT(flen, model, rt)
%find RT with the R in frame 1 included

T = size(rt,3);       %rt=3,4,T
if (T~=1)
    error('rt size must be 3*4*1 only (T must equal to 1');
end
N = size(model,2);    
J=zeros(2*N,6);	 

%1:3T columns for translation
%X = rt*model;		%X=RM+T
XXR = rt*model;		%X=RM+T

%XR = rt(1:3,1:3)*model(1:3,:); %XR=RM
XR=XXR(1,:)
YR=XXR(2,:)
ZR=XXR(3,:)
%ZR2=XXR(3,:).*XXR(3,:)

X=model(1,:)
Y=model(2,:)
Z=model(3,:)

%Z2 = XR(3,:).*XR(3,:);

%translation part
%x1 = 1./X(3,:);
x1 = 1./ZR;

x2 = zeros(1,N);

%x3 = -X(1,:)./Z2;
x3 = -XR./ZR.^2

y1 = zeros(1,N);

%y2 = 1/x1;
y2= 1./ZR;

y3 = -YR./(ZR).^2;
J(:,1:3) = [x1' x2' x3'; y1' y2' y3'];

%rotation part
%x1 = -X(1,:).*XR(2,:)./Z2;       %dxdalpha, orgional
x1 = -(Y.*XR)./(ZR).^2;       %dxdalpha, fix khwong 040412

%x2 = (X(1,:).*XR(1,:)+X(3,:).*XR(3,:))./Z2;
x2 = (X.*XR+Z.*ZR)./(ZR).^2;

%x3 = -XR(2,:)./X(3,:); %problem  ***
x3 = -Y./ZR;


%y1 = -(X(2,:).*XR(2,:)+X(3,:).*XR(3,:))./Z2;
y1 = -(Y.*YR+Z.*ZR)./(ZR).^2;

%y2 = (XR(1,:).*X(2,:))./Z2;
y2 = (XR.*X)./(ZR).^2;

%y3 = XR(1,:)./X(3,:);
y3 = X./(ZR).^2;
J(:,4:6) = [x1' x2' x3'; y1' y2' y3'];

%J = flen.*J;
J = flen*J;

% %jacob_full(
% function J=JacobRT_full_i(f, model_i,theta )
% Xi=model_i(1);
% Yi=model_i(2);
% Zi=model_i(3);
% Ti1=theta(1);
% Ti2=theta(2);
% Ti3=theta(3);
% a=theta(3);
% b=theta(4);
% c=theta(5);
% %function jacob_full(f Xi Yi Zi Ti1 Ti2 Ti3 a b c)
% J=[ f/(Ti3 + Xi*(sin(a)*sin(c) - cos(a)*cos(c)*sin(b)) + Yi*(cos(c)*sin(a) + cos(a)*sin(b)*sin(c)) + Zi*cos(a)*cos(b)),                                                                                                                  0,                                                      -(f*(Ti1 + Zi*sin(b) + Xi*cos(b)*cos(c) - Yi*cos(b)*sin(c)))/(Ti3 + Xi*(sin(a)*sin(c) - cos(a)*cos(c)*sin(b)) + Yi*(cos(c)*sin(a) + cos(a)*sin(b)*sin(c)) + Zi*cos(a)*cos(b))^2,                                                                                                                                                                                                                                                                                       -(f*(Xi*(cos(a)*sin(c) + cos(c)*sin(a)*sin(b)) + Yi*(cos(a)*cos(c) - sin(a)*sin(b)*sin(c)) - Zi*cos(b)*sin(a))*(Ti1 + Zi*sin(b) + Xi*cos(b)*cos(c) - Yi*cos(b)*sin(c)))/(Ti3 + Xi*(sin(a)*sin(c) - cos(a)*cos(c)*sin(b)) + Yi*(cos(c)*sin(a) + cos(a)*sin(b)*sin(c)) + Zi*cos(a)*cos(b))^2,                                                                         (f*(Zi*cos(b) - Xi*cos(c)*sin(b) + Yi*sin(b)*sin(c)))/(Ti3 + Xi*(sin(a)*sin(c) - cos(a)*cos(c)*sin(b)) + Yi*(cos(c)*sin(a) + cos(a)*sin(b)*sin(c)) + Zi*cos(a)*cos(b)) + (f*(Zi*cos(a)*sin(b) + Xi*cos(a)*cos(b)*cos(c) - Yi*cos(a)*cos(b)*sin(c))*(Ti1 + Zi*sin(b) + Xi*cos(b)*cos(c) - Yi*cos(b)*sin(c)))/(Ti3 + Xi*(sin(a)*sin(c) - cos(a)*cos(c)*sin(b)) + Yi*(cos(c)*sin(a) + cos(a)*sin(b)*sin(c)) + Zi*cos(a)*cos(b))^2,                                                                                                    - (f*(Yi*cos(b)*cos(c) + Xi*cos(b)*sin(c)))/(Ti3 + Xi*(sin(a)*sin(c) - cos(a)*cos(c)*sin(b)) + Yi*(cos(c)*sin(a) + cos(a)*sin(b)*sin(c)) + Zi*cos(a)*cos(b)) - (f*(Xi*(cos(c)*sin(a) + cos(a)*sin(b)*sin(c)) - Yi*(sin(a)*sin(c) - cos(a)*cos(c)*sin(b)))*(Ti1 + Zi*sin(b) + Xi*cos(b)*cos(c) - Yi*cos(b)*sin(c)))/(Ti3 + Xi*(sin(a)*sin(c) - cos(a)*cos(c)*sin(b)) + Yi*(cos(c)*sin(a) + cos(a)*sin(b)*sin(c)) + Zi*cos(a)*cos(b))^2
%                                                                                                                   0, 1/(Ti3 + Xi*(sin(a)*sin(c) - cos(a)*cos(c)*sin(b)) + Yi*(cos(c)*sin(a) + cos(a)*sin(b)*sin(c)) + Zi*cos(a)*cos(b)), -(Ti2 + Xi*(cos(a)*sin(c) + cos(c)*sin(a)*sin(b)) + Yi*(cos(a)*cos(c) - sin(a)*sin(b)*sin(c)) - Zi*sin(a)*sin(b))/(Ti3 + Xi*(sin(a)*sin(c) - cos(a)*cos(c)*sin(b)) + Yi*(cos(c)*sin(a) + cos(a)*sin(b)*sin(c)) + Zi*cos(a)*cos(b))^2, - (Xi*(sin(a)*sin(c) - cos(a)*cos(c)*sin(b)) + Yi*(cos(c)*sin(a) + cos(a)*sin(b)*sin(c)) + Zi*cos(a)*sin(b))/(Ti3 + Xi*(sin(a)*sin(c) - cos(a)*cos(c)*sin(b)) + Yi*(cos(c)*sin(a) + cos(a)*sin(b)*sin(c)) + Zi*cos(a)*cos(b)) - ((Xi*(cos(a)*sin(c) + cos(c)*sin(a)*sin(b)) + Yi*(cos(a)*cos(c) - sin(a)*sin(b)*sin(c)) - Zi*cos(b)*sin(a))*(Ti2 + Xi*(cos(a)*sin(c) + cos(c)*sin(a)*sin(b)) + Yi*(cos(a)*cos(c) - sin(a)*sin(b)*sin(c)) - Zi*sin(a)*sin(b)))/(Ti3 + Xi*(sin(a)*sin(c) - cos(a)*cos(c)*sin(b)) + Yi*(cos(c)*sin(a) + cos(a)*sin(b)*sin(c)) + Zi*cos(a)*cos(b))^2, ((Zi*cos(a)*sin(b) + Xi*cos(a)*cos(b)*cos(c) - Yi*cos(a)*cos(b)*sin(c))*(Ti2 + Xi*(cos(a)*sin(c) + cos(c)*sin(a)*sin(b)) + Yi*(cos(a)*cos(c) - sin(a)*sin(b)*sin(c)) - Zi*sin(a)*sin(b)))/(Ti3 + Xi*(sin(a)*sin(c) - cos(a)*cos(c)*sin(b)) + Yi*(cos(c)*sin(a) + cos(a)*sin(b)*sin(c)) + Zi*cos(a)*cos(b))^2 - (Zi*cos(b)*sin(a) - Xi*cos(b)*cos(c)*sin(a) + Yi*cos(b)*sin(a)*sin(c))/(Ti3 + Xi*(sin(a)*sin(c) - cos(a)*cos(c)*sin(b)) + Yi*(cos(c)*sin(a) + cos(a)*sin(b)*sin(c)) + Zi*cos(a)*cos(b)), (Xi*(cos(a)*cos(c) - sin(a)*sin(b)*sin(c)) - Yi*(cos(a)*sin(c) + cos(c)*sin(a)*sin(b)))/(Ti3 + Xi*(sin(a)*sin(c) - cos(a)*cos(c)*sin(b)) + Yi*(cos(c)*sin(a) + cos(a)*sin(b)*sin(c)) + Zi*cos(a)*cos(b)) - ((Xi*(cos(c)*sin(a) + cos(a)*sin(b)*sin(c)) - Yi*(sin(a)*sin(c) - cos(a)*cos(c)*sin(b)))*(Ti2 + Xi*(cos(a)*sin(c) + cos(c)*sin(a)*sin(b)) + Yi*(cos(a)*cos(c) - sin(a)*sin(b)*sin(c)) - Zi*sin(a)*sin(b)))/(Ti3 + Xi*(sin(a)*sin(c) - cos(a)*cos(c)*sin(b)) + Yi*(cos(c)*sin(a) + cos(a)*sin(b)*sin(c)) + Zi*cos(a)*cos(b))^2]
% %%% Jacob gen from the following code
% % % Solve the problem without simplification Since  is the yaw, pitch, roll
% % % of the rotation respectively. The R can be represent by   as:
% % %  
% % % Substitute R into (1), we have the following program (in matlab):
% % %************************************************************************
% % function TestJacobian
% % % Try to solve the differentiate equations without simplification
% % clc,clear;
% % disp('TestJacobian');
% % 
% % syms a b c; % yaw, pitch, roll respectively
% % syms f Xi Yi Zi Ti1 Ti2 Ti3;
% % F = [
% % %u
% % f*((cos(b)*cos(c)*Xi - cos(b)*sin(c)*Yi + sin(b)*Zi + Ti1)/((-cos(a)*sin(b)*cos(c) + sin(a)*sin(c))*Xi + (cos(a)*sin(b)*sin(c)+ sin(a)*cos(c))*Yi + cos(a)*cos(b)*Zi + Ti3));
% % %v
% % ((sin(a)*sin(b)*cos(c)+ cos(a)*sin(c))*Xi + (-sin(a)*sin(b)*sin(c)+ cos(a)*cos(c))*Yi - sin(a)*sin(b)*Zi + Ti2)/((-cos(a)*sin(b)*cos(c) + sin(a)*sin(c))*Xi + (cos(a)*sin(b)*sin(c)+ sin(a)*cos(c))*Yi + cos(a)*cos(b)*Zi + Ti3);]
% % 
% % V = [Ti1,Ti2,Ti3,a,b,c];
% % F_xlowe_full = jacobian(F,V);
% % disp('F_xlowe_full =');
% % disp(F_xlowe_full);
% % %************************

% Author: Rodrigo Carceroni
% Disclaimer: This code comes with no guarantee at all and its author
%   is not liable for any damage that its utilization may cause.

function R = rpyMat (angs)

% Return the 3x3 rotation matrix described by a set of Roll, Pitch and Yaw
% angles.

cosA = cos (angs(3));
sinA = sin (angs(3));
cosB = cos (angs(2));
sinB = sin (angs(2));
cosC = cos (angs(1));
sinC = sin (angs(1));

cosAsinB = cosA .* sinB;
sinAsinB = sinA .* sinB;

R = [ cosA.*cosB  cosAsinB.*sinC-sinA.*cosC  cosAsinB.*cosC+sinA.*sinC ;
    sinA.*cosB  sinAsinB.*sinC+cosA.*cosC  sinAsinB.*cosC-cosA.*sinC ;
    -sinB            cosB.*sinC                 cosB.*cosC         ];

function angles = rotate_angles(R)
T = size(R,3);      %R=3*3*T
angles=zeros(1,T);
for t=1:T
    %Rn=r*R1 => r=Rn*R1'
    r = R(:,:,t)*R(:,:,1)';
    A = 0.5*(r-r');
    a = 0.5*sum(sum(A.^2));
    angles(t) = asin(sqrt(a));
end
