function Solution = pose_est(Model, ActualImg, InitTr, fLen, numIter)
%ref: ishii pose esimation
actual_image=ActualImg;
%Model=  a 3x n matrix
%ActulImg = 2xn matrix
%InitTr = 4x4 matrix
%fLen=foccal length
%numIter=number of iterations
%Soultion = 6x1

[m n]= size(Model);
%preallocation optimzation

ReconImg=zeros(2,n);
err=zeros(2.*n,1);
Jacob=zeros(2.*n,6);

% Extract the initial estimates for the parameers
Rot=InitTr(1:3,1:3);
dists=InitTr(1:3,4);
%main loop
iter =0;
while 1
    %project the model
    RMod=Rot * Model;
    for r=1:2
        ReconImg(r,:)=fLen.*(RMod(r,:)+dists(r)) ./ (RMod(3,:)+dists(3));
    end
    
    %%%plot images%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    figure(1)
    clf
    hold on
    plot(actual_image(1,:),actual_image(2,:),'ro');
    plot(ReconImg(1,:),ReconImg(2,:),'bx');
    title('image features')
    %%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
        
    Dif=ActualImg - ReconImg;
    %check the top doniston
    if(iter >numIter(1))
        break;
    else
        iter=iter +1;
    end;
    %compute the error vector and the jaco matrix
    for pt =1:n
        pt2=2 .* pt;
        err(pt2-1:pt2)=Dif(:,pt);
        
        x=Model(1,pt);
        y=Model(2,pt);
        z=Model(3,pt);
        
        XR=x+dists(1);%XR
        YR=y+dists(2);%YR
        ZR=z+dists(3);%ZR
                
        Jacob(pt2-1:pt2,:)=...
           [fLen/ZR 0       -(fLen*x)/(ZR^2) -(fLen*y*XR)/(ZR^2)      fLen*(x*XR+z*ZR)/(ZR^2) -fLen*y/ZR
            0       fLen/ZR -(fLen*y)/(ZR^2) -fLen*(y*YR+z*ZR)/(ZR^2) fLen*YR*x/(ZR^2)         fLen*x/ZR];
  
    end;
    Jacob
    delta=Jacob \ err;
    dists = dists + delta(1:3);
    
    Rot= roll_pitch_yaw_2R ([delta(4:6)]) * Rot; %orginal  method
    
    error(iter)=sum(err.*err)
    
end;
%record the solution
Solution = [dists; R2roll_pitch_yaw(Rot)];
figure(2)
clf
size(error)
plot(error(1,:))
error(length(error))